/******************************************
	 Schlurp - Joueur virtuel
	 Pour Schlurp version 2 - Win32
	 (c) Pascal Peyremorte 1999
     (c) <votre nom>
******************************************/

/***************************************************************
NOM DU JOUEUR
C'est le nom qui apparatra dans les menus 'Joueurs' de Schlurp
par exemple 'Pascal P. V1.0' pour mon module initial
**************************************************************/
#define MON_NOM "Votre nom SVP"

/******************************************
	Squelette pour Builder C++
    (c) JMV J.M.V@wanadoo.fr
    version V1.0
    Driv de la version de Yanos El Guerilleros pour Borland C++
******************************************/

/*-----------------------------------------------------------------------------
  Dclarations -  ne pas modifier -
-----------------------------------------------------------------------------*/
#pragma hdrstop
#include <string.h>

/* Taille du tableau */
#define  CaseMax 6 			/* Damier de 7x7	*/

/* Valeurs associes au contenu des cases du plateau */
#define VIDE (byte)0		/* Case vide */
#define J1   (byte)1		/* Case occupe par le joueur 1 */
#define J2   (byte)2		/* Case occupe par le joueur 2 */

/*-- Dfinition de type compatible Delphi */
typedef unsigned char byte;	/*-- Type byte est un octet non sign */

typedef struct
{						/*-- pour le ShortString j'ai cr une structure */
	byte Size;			/*-- par fainantise pour la suite */
	char Text[255];
} PascalString;

/* Contenu du plateau, indice X puis Y : Damier[Colonne][Ligne] */
typedef  byte TDamier[CaseMax+1][CaseMax+1];

typedef struct
{
	byte XD, YD;		/* Case de dpart */
	byte XA, YA;		/* Case d'arrive */
} TCoup;


/*-----------------------------------------------------------------------------
	Identification joueur, version et plateau
**---------------------------------------------------------------------------*/
extern "C" PascalString  _export __stdcall GetPlayerName()
{
	PascalString Result;
	/*-- Copie du nom */
	strcpy(Result.Text, MON_NOM);
	/*-- Calcul de la taille du nom */
	Result.Size=(byte)strlen(Result.Text);
	/*-- retourne le rsultat */
	return Result;
}

/* Cette fonction n'est actuellement utilise que pour contrle.
 Elle pourra devenir intressante si le programme principal est modifi
 pour supporter plusieurs tailles de plateau, afin d'optimiser les algorithmes
 relativement  une taille donnes.
 Actuellement une dll ne rpondant pas 7 est ignore */

extern"C" int _export __stdcall GetBoardSize()
{
	return CaseMax+1;
}


/*-----------------------------------------------------------------------------
	Evaluation d'un coup (fumant...)
-----------------------------------------------------------------------------*/

/*Cette fonction retourne les coordonnes de dpart et d'arrive du pion  jouer.
 Elle n'est appele que si un coup au moins est jouable.

 Elle reoit en paramtre l'tat actuel du plateau dans Damier[X,Y] et
 le numro du joueur pour qui il faut rflchir...

 Dans Damier, chaque case contient la valeur
	 - <Vide> (=0) si elle est ... vide,
	 - <J1>   (=1) si elle est occupe par un pion du joueur 1
	 - <J2>   (=2) si elle est occupe par un pion du joueur 2

 Joueur vaut <J1> ou <J2>*/

extern"C" TCoup _export __stdcall ComputeMove(TDamier Damier,byte Joueur)
{
	char i,j;
    char i2,j2;

	/*-- Ici je cr le coup que je vais calculer */
	TCoup MonCoup;

	/*--	Pour tester la DLL je me contente de chercher
			le premier dplacement d'une case que je
			peux faire
			ATTENTION, il sera considr comme tricheur
			si il le dernier coup qu'il peut faire se
			rvle tre un dplacement de deux cases
			C'EST JUSTE POUR TESTER :))) */

	for(i=0;i<=CaseMax;i++)
	{
    	for(j=0;j<=CaseMax;j++)
		{
        	if(Damier[i][j]==Joueur)
			{
				/*-- J'ai un pion qui m'appartient */
				MonCoup.XD=i;	MonCoup.YD=j;

				/*-- Je cherche la premire case vide autour */
                for(i2=i-2; i2<=i+2; i2++)
                {
 	               	for(j2=j-2; j2<=j+2; j2++)
                   	{
                        /* suis-je dans le damier ?*/
                		if(i2 >= 0 && i2 <= CaseMax && j2 >= 0 && j2 <= CaseMax)
						{	if(Damier[i2][j2]==VIDE)
                            {
                            	MonCoup.XA=i2;
                                MonCoup.YA=j2;
                                return MonCoup;
                            }
                        }
                   	}
                }
            }
        }
    }
} /* ouf !*/

